/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>

void WREN();
void transmit_address(uint8_t hi, uint8_t med, uint8_t low);

int main_short()
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    SPIM_1_Start();
    LCD_Start();
    LCD_DisplayOn();
    
    uint8_t addr_hi = 0x00;
    uint8_t addr_med = 0x00;
    uint8_t addr_low = 0x00;
    
    SS_Write(0);
    SPIM_1_WriteTxData(0x06);
    while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
    SS_Write(1);    
    
    SS_Write(0);
    SPIM_1_WriteTxData(0x01);
    SPIM_1_WriteTxData(0x00);
    while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
    SS_Write(1);
    
    uint8_t num_strings = 0;

    char read_string[16] = {0};
    
    for(;;)
    {
        if(!SW2_Read()){
            if (num_strings == 0){
                WREN();
                
                SS_Write(0);
                SPIM_1_WriteTxData(0x02);
                SPIM_1_WriteTxData(addr_hi);
                SPIM_1_WriteTxData(addr_med);
                SPIM_1_WriteTxData(addr_low);
                SPIM_1_PutArray("6.115", 6);
                while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
                SS_Write(1);
                
                addr_low += 5;
                num_strings ++;
            }
            else if (num_strings == 1){
                WREN();
                
                SS_Write(0);
                SPIM_1_WriteTxData(0x02);
                transmit_address(addr_hi, addr_med, addr_low);
                SPIM_1_WriteTxData(' ');
                SPIM_1_PutArray("is", 3);
                while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
                SS_Write(1);
                
                addr_low += 3;
                num_strings ++;
            }            
            else if (num_strings == 2){
                WREN();
                
                SS_Write(0);
                SPIM_1_WriteTxData(0x02);
                transmit_address(addr_hi, addr_med, addr_low);
                SPIM_1_WriteTxData(' ');
                SPIM_1_PutArray("cool!!", 7);
                while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
                SS_Write(1);
                
                addr_low += 7;
                num_strings ++;
            }
            CyDelay(250);
        }
        else if(!SW3_Read()){
            SS_Write(0);
            SPIM_1_WriteTxData(0x03);
            transmit_address(0x00, 0x00, 0x00);
            while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
            
            SPIM_1_ClearRxBuffer();
            
            int i;
            for (i = 0; i < 16; i ++){
                SPIM_1_WriteTxData(0xAA);
                while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
                read_string[i] = SPIM_1_ReadRxData();
                if (read_string[i] == 0) break;
            }
            SS_Write(1);

            LCD_ClearDisplay();
            LCD_PrintString(read_string);
            CyDelay(250);
        }
    }
}
   
void WREN (){
    SS_Write(0);
    SPIM_1_WriteTxData(0x06);
    while(!(SPIM_1_ReadTxStatus() & SPIM_1_STS_SPI_DONE));
    SS_Write(1);
}

void transmit_address (uint8_t hi, uint8_t med, uint8_t low){
    SPIM_1_WriteTxData(hi);
    SPIM_1_WriteTxData(med);
    SPIM_1_WriteTxData(low);
}

/* [] END OF FILE */
